using System;
using System.Collections.Generic;
using System.Text;

#pragma warning disable CS1591

namespace $rootnamespace$.Bd 
{
	public static partial class Rf_sga_pkg
	{
					#region CALCULAR_GACAJA_COD
			
			[Nombre("RF_SGA_PKG.CALCULAR_GACAJA_COD")]
						[return: VARCHAR2]
						public delegate string __CALCULAR_GACAJA_COD_VVVVVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_gvpalletip_cod, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2] string p_opcion, 
							[VARCHAR2] string p_mostrar_traza_sn, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a CALCULAR_GACAJA_COD.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static string CALCULAR_GACAJA_COD(
				System.Data.IDbTransaction p_transaccion, 
				string p_gvpalletip_cod, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_opcion, 
				string p_mostrar_traza_sn, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__CALCULAR_GACAJA_COD_VVVVVoV v_calcular_gacaja_cod;
				try {
					v_calcular_gacaja_cod = Funcion.Crear<__CALCULAR_GACAJA_COD_VVVVVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.CALCULAR_GACAJA_COD", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_calcular_gacaja_cod(p_transaccion, 
					p_gvpalletip_cod, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_opcion, 
					p_mostrar_traza_sn, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.CALCULAR_GACAJA_COD", ex);
								}
									return v_resultado;
							}
			
							/// <summary>
				/// Llama a CALCULAR_GACAJA_COD y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static string CALCULAR_GACAJA_COD(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_gvpalletip_cod, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2] string p_opcion, 
					[VARCHAR2] string p_mostrar_traza_sn)
				{
					
					var v_resultado = CALCULAR_GACAJA_COD(p_transaccion, 
						p_gvpalletip_cod, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_opcion, 
						p_mostrar_traza_sn,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.CALCULAR_GACAJA_COD");
					
										
											return v_resultado;
									}	
			
			#endregion

					#region CONFIRMA_GACAJACONT
			
			[Nombre("RF_SGA_PKG.CONFIRMA_GACAJACONT")]
						public delegate void __CONFIRMA_GACAJACONT_VVVVNNVNNVNNioVioNioVVNNDDVVVVVVVoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_gglptip_cod, 
							[NUMBER] int? p_n_lp, 
							[NUMBER] int? p_n_lin_lp, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[NUMBER] int? p_n_lin_ped, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[NUMBER(13, 4)] decimal? p_c_uni1, 
							[NUMBER(13, 4)] decimal? p_c_uni2, 
							[VARCHAR2(8)] ref string p_ggalbtip_cod, 
							[NUMBER] ref int? p_n_albaran, 
							[VARCHAR2(4)] ref string p_n_lin_alb, 
							[VARCHAR2(4)] string p_gvpalletip_cod, 
							[NUMBER] int? p_n_bulto, 
							[NUMBER] int? p_p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_conf_picking_permite_comp, 
							[VARCHAR2(400)] string picking_extraer_caja_orden, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a CONFIRMA_GACAJACONT.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void CONFIRMA_GACAJACONT(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_gglptip_cod, 
				int? p_n_lp, 
				int? p_n_lin_lp, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				int? p_n_lin_ped, 
				string p_gacaja_cod, 
				decimal? p_c_uni1, 
				decimal? p_c_uni2, 
				ref string p_ggalbtip_cod, 
				ref int? p_n_albaran, 
				ref string p_n_lin_alb, 
				string p_gvpalletip_cod, 
				int? p_n_bulto, 
				int? p_p_ggclipr_cod, 
				DateTime? p_f_ped, 
				DateTime? p_galotes_min_f_cad, 
				string sga_gaubic_picking_cond, 
				string sga_conf_picking_permite_comp, 
				string picking_extraer_caja_orden, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__CONFIRMA_GACAJACONT_VVVVNNVNNVNNioVioNioVVNNDDVVVVVVVoVoV v_confirma_gacajacont;
				try {
					v_confirma_gacajacont = Funcion.Crear<__CONFIRMA_GACAJACONT_VVVVNNVNNVNNioVioNioVVNNDDVVVVVVVoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.CONFIRMA_GACAJACONT", ex);
								}
								try {
				v_confirma_gacajacont(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_gglptip_cod, 
					p_n_lp, 
					p_n_lin_lp, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					p_n_lin_ped, 
					p_gacaja_cod, 
					p_c_uni1, 
					p_c_uni2, 
					ref p_ggalbtip_cod, 
					ref p_n_albaran, 
					ref p_n_lin_alb, 
					p_gvpalletip_cod, 
					p_n_bulto, 
					p_p_ggclipr_cod, 
					p_f_ped, 
					p_galotes_min_f_cad, 
					sga_gaubic_picking_cond, 
					sga_conf_picking_permite_comp, 
					picking_extraer_caja_orden, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.CONFIRMA_GACAJACONT", ex);
								}
							}
			
							/// <summary>
				/// Llama a CONFIRMA_GACAJACONT y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void CONFIRMA_GACAJACONT(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[VARCHAR2(8)] string p_gglptip_cod, 
					[NUMBER] int? p_n_lp, 
					[NUMBER] int? p_n_lin_lp, 
					[VARCHAR2(8)] string p_ggpedtip_cod, 
					[NUMBER] int? p_n_pedido, 
					[NUMBER] int? p_n_lin_ped, 
					[VARCHAR2(20)] string p_gacaja_cod, 
					[NUMBER(13, 4)] decimal? p_c_uni1, 
					[NUMBER(13, 4)] decimal? p_c_uni2, 
					[VARCHAR2(8)] ref string p_ggalbtip_cod, 
					[NUMBER] ref int? p_n_albaran, 
					[VARCHAR2(4)] ref string p_n_lin_alb, 
					[VARCHAR2(4)] string p_gvpalletip_cod, 
					[NUMBER] int? p_n_bulto, 
					[NUMBER] int? p_p_ggclipr_cod, 
					[DATE] DateTime? p_f_ped, 
					[DATE] DateTime? p_galotes_min_f_cad, 
					[VARCHAR2(400)] string sga_gaubic_picking_cond, 
					[VARCHAR2(400)] string sga_conf_picking_permite_comp, 
					[VARCHAR2(400)] string picking_extraer_caja_orden, 
					[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
					[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
					[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
					[VARCHAR2(400)] string sga_extraer_f_cad_dias_def, 
					[VARCHAR2] out string p_mensaje_info)
				{
											var v_copia_p_ggalbtip_cod = p_ggalbtip_cod;
				    						var v_copia_p_n_albaran = p_n_albaran;
				    						var v_copia_p_n_lin_alb = p_n_lin_alb;
				    
					CONFIRMA_GACAJACONT(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_tip_vc, 
						p_gglptip_cod, 
						p_n_lp, 
						p_n_lin_lp, 
						p_ggpedtip_cod, 
						p_n_pedido, 
						p_n_lin_ped, 
						p_gacaja_cod, 
						p_c_uni1, 
						p_c_uni2, 
						ref v_copia_p_ggalbtip_cod, 
						ref v_copia_p_n_albaran, 
						ref v_copia_p_n_lin_alb, 
						p_gvpalletip_cod, 
						p_n_bulto, 
						p_p_ggclipr_cod, 
						p_f_ped, 
						p_galotes_min_f_cad, 
						sga_gaubic_picking_cond, 
						sga_conf_picking_permite_comp, 
						picking_extraer_caja_orden, 
						sga_extraer_f_cad_tratar, 
						sga_extraer_f_cad_gaclatip_cod, 
						sga_extraer_f_cad_def_gaclatip, 
						sga_extraer_f_cad_dias_def, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.CONFIRMA_GACAJACONT");
					
											p_ggalbtip_cod = v_copia_p_ggalbtip_cod;
				    						p_n_albaran = v_copia_p_n_albaran;
				    						p_n_lin_alb = v_copia_p_n_lin_alb;
				    						p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region DAME_ALBARANES_PED
			 
					public interface IDAME_ALBARANES_PED 
{
			string TIPO { get; }
			int? N_ALBARAN { get; }
			string ESTADO { get; }
			DateTime? F_ALBARAN { get; }
			string SU_REF_ALB { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_ALBARANES_PED")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_ALBARANES_PED> __DAME_ALBARANES_PED_VVVVN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_opc, 
							[VARCHAR2(4)] string p_emp_opc, 
							[VARCHAR2(1)] string p_tip_vc_opc, 
							[VARCHAR2(8)] string p_ggpedtip_opc, 
							[NUMBER] int? p_ggpedlin_n_ped);

						/// <summary>
			/// Llama a DAME_ALBARANES_PED.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_ALBARANES_PED> DAME_ALBARANES_PED(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_opc, 
				string p_emp_opc, 
				string p_tip_vc_opc, 
				string p_ggpedtip_opc, 
				int? p_ggpedlin_n_ped,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_ALBARANES_PED_VVVVN v_dame_albaranes_ped;
				try {
					v_dame_albaranes_ped = Funcion.Crear<__DAME_ALBARANES_PED_VVVVN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_ALBARANES_PED", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_ALBARANES_PED> v_resultado;
								try {
				v_resultado = v_dame_albaranes_ped(p_transaccion, 
					p_empgrupo_opc, 
					p_emp_opc, 
					p_tip_vc_opc, 
					p_ggpedtip_opc, 
					p_ggpedlin_n_ped);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_ALBARANES_PED", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_BULTOS
			 
					public interface IDAME_BULTOS 
{
			string TIP_VC { get; }
			string GGALBTIP_COD { get; }
			int? N_ALBARAN { get; }
			int? N_BULTO { get; }
			string GVPALLETIP_COD { get; }
			string GACAJA_COD { get; }
			decimal? C_UNI1 { get; }
			decimal? C_UNI2 { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_BULTOS")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_BULTOS> __DAME_BULTOS_VVVVNNVN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[NUMBER] int? p_n_lin, 
							[VARCHAR2(8)] string p_ggalbtip_cod, 
							[NUMBER] int? p_n_albaran);

						/// <summary>
			/// Llama a DAME_BULTOS.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_BULTOS> DAME_BULTOS(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				int? p_n_lin, 
				string p_ggalbtip_cod, 
				int? p_n_albaran,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_BULTOS_VVVVNNVN v_dame_bultos;
				try {
					v_dame_bultos = Funcion.Crear<__DAME_BULTOS_VVVVNNVN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_BULTOS", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_BULTOS> v_resultado;
								try {
				v_resultado = v_dame_bultos(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					p_n_lin, 
					p_ggalbtip_cod, 
					p_n_albaran);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_BULTOS", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_CANTIDAD_ARTICULO_PICKING
			
			[Nombre("RF_SGA_PKG.DAME_CANTIDAD_ARTICULO_PICKING")]
						public delegate void __DAME_CANTIDAD_ARTICULO_PICKING_VVVoNoN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[NUMBER(13, 4)] out decimal? p_c_unid1, 
							[NUMBER(13, 4)] out decimal? p_c_unid2);

						/// <summary>
			/// Llama a DAME_CANTIDAD_ARTICULO_PICKING.
						/// </summary>
			public static void DAME_CANTIDAD_ARTICULO_PICKING(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gaalmnom_cod, 
				string p_gaart_cod, 
				out decimal? p_c_unid1, 
				out decimal? p_c_unid2,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_CANTIDAD_ARTICULO_PICKING_VVVoNoN v_dame_cantidad_articulo_picking;
				try {
					v_dame_cantidad_articulo_picking = Funcion.Crear<__DAME_CANTIDAD_ARTICULO_PICKING_VVVoNoN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_CANTIDAD_ARTICULO_PICKING", ex);
								}
								try {
				v_dame_cantidad_articulo_picking(p_transaccion, 
					p_empgrupo_cod, 
					p_gaalmnom_cod, 
					p_gaart_cod, 
					out p_c_unid1, 
					out p_c_unid2);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_CANTIDAD_ARTICULO_PICKING", ex);
								}
							}
			
			
			#endregion

					#region DAME_CURSOR_GACAJAINVEN_USR
			 
					public interface IDAME_CURSOR_GACAJAINVEN_USR 
{
			string USRNOM_COD { get; }
			DateTime? FECHA { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_CURSOR_GACAJAINVEN_USR")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_CURSOR_GACAJAINVEN_USR> __DAME_CURSOR_GACAJAINVEN_USR(
							System.Data.IDbTransaction p_transaccion);

						/// <summary>
			/// Llama a DAME_CURSOR_GACAJAINVEN_USR.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_CURSOR_GACAJAINVEN_USR> DAME_CURSOR_GACAJAINVEN_USR(
				System.Data.IDbTransaction p_transaccion,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_CURSOR_GACAJAINVEN_USR v_dame_cursor_gacajainven_usr;
				try {
					v_dame_cursor_gacajainven_usr = Funcion.Crear<__DAME_CURSOR_GACAJAINVEN_USR>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_CURSOR_GACAJAINVEN_USR", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_CURSOR_GACAJAINVEN_USR> v_resultado;
								try {
				v_resultado = v_dame_cursor_gacajainven_usr(p_transaccion);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_CURSOR_GACAJAINVEN_USR", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_CURSOR_SSCC_GGALBLCAJA
			 
					public interface IDAME_CURSOR_SSCC_GGALBLCAJA 
{
			string GACAJA_COD { get; }
			decimal? C_UNI1 { get; }
			decimal? C_UNI2 { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_CURSOR_SSCC_GGALBLCAJA")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_CURSOR_SSCC_GGALBLCAJA> __DAME_CURSOR_SSCC_GGALBLCAJA_VVVVNVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(20)] string p_lote);

						/// <summary>
			/// Llama a DAME_CURSOR_SSCC_GGALBLCAJA.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_CURSOR_SSCC_GGALBLCAJA> DAME_CURSOR_SSCC_GGALBLCAJA(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				string p_gaart_cod, 
				string p_lote,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_CURSOR_SSCC_GGALBLCAJA_VVVVNVV v_dame_cursor_sscc_ggalblcaja;
				try {
					v_dame_cursor_sscc_ggalblcaja = Funcion.Crear<__DAME_CURSOR_SSCC_GGALBLCAJA_VVVVNVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_CURSOR_SSCC_GGALBLCAJA", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_CURSOR_SSCC_GGALBLCAJA> v_resultado;
								try {
				v_resultado = v_dame_cursor_sscc_ggalblcaja(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					p_gaart_cod, 
					p_lote);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_CURSOR_SSCC_GGALBLCAJA", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_DATOS_EXTRACCION_CAJAS
			 
					public interface IDAME_DATOS_EXTRACCION_CAJAS 
{
			string GAUBIC_COD { get; }
			string GACAJA_COD { get; }
			decimal? C_UNI1 { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_DATOS_EXTRACCION_CAJAS")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_CAJAS> __DAME_DATOS_EXTRACCION_CAJAS_VVVVVNVVVNDDVVVVVVVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2] string p_lote, 
							[VARCHAR2] string p_gaubic_cod, 
							[NUMBER] decimal? p_c_uni1_extraer, 
							[VARCHAR2] string p_opcion, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string gaubic_criterio_extraer_caja, 
							[VARCHAR2(400)] string sga_criterio_extraer_caja, 
							[VARCHAR2(400)] string gacaja_gaubic_def, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_gaubic_expedicion, 
							[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def);

						/// <summary>
			/// Llama a DAME_DATOS_EXTRACCION_CAJAS.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_CAJAS> DAME_DATOS_EXTRACCION_CAJAS(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gaart_cod, 
				string p_gaalmnom_cod, 
				string p_lote, 
				string p_gaubic_cod, 
				decimal? p_c_uni1_extraer, 
				string p_opcion, 
				string p_emp_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				DateTime? p_galotes_min_f_cad, 
				string gaubic_criterio_extraer_caja, 
				string sga_criterio_extraer_caja, 
				string gacaja_gaubic_def, 
				string sga_gaubic_picking_cond, 
				string sga_gaubic_expedicion, 
				string sga_gacaja_ggestado_exped_perm, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_DATOS_EXTRACCION_CAJAS_VVVVVNVVVNDDVVVVVVVVVV v_dame_datos_extraccion_cajas;
				try {
					v_dame_datos_extraccion_cajas = Funcion.Crear<__DAME_DATOS_EXTRACCION_CAJAS_VVVVVNVVVNDDVVVVVVVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DATOS_EXTRACCION_CAJAS", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_CAJAS> v_resultado;
								try {
				v_resultado = v_dame_datos_extraccion_cajas(p_transaccion, 
					p_empgrupo_cod, 
					p_gaart_cod, 
					p_gaalmnom_cod, 
					p_lote, 
					p_gaubic_cod, 
					p_c_uni1_extraer, 
					p_opcion, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					p_galotes_min_f_cad, 
					gaubic_criterio_extraer_caja, 
					sga_criterio_extraer_caja, 
					gacaja_gaubic_def, 
					sga_gaubic_picking_cond, 
					sga_gaubic_expedicion, 
					sga_gacaja_ggestado_exped_perm, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DATOS_EXTRACCION_CAJAS", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_DATOS_EXTRACCION_PRIOR
			 
					public interface IDAME_DATOS_EXTRACCION_PRIOR 
{
			string GAUBIC_COD { get; }
			string GACAJA_COD { get; }
			decimal? C_UNI1 { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_DATOS_EXTRACCION_PRIOR")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_PRIOR> __DAME_DATOS_EXTRACCION_PRIOR_VVVVVNVVVNDDVVVVVVVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2] string p_lote, 
							[VARCHAR2] string p_gaubic_cod, 
							[NUMBER] decimal? p_c_uni1_extraer, 
							[VARCHAR2] string p_opcion, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string gaubic_criterio_extraer_caja, 
							[VARCHAR2(400)] string sga_criterio_extraer_caja, 
							[VARCHAR2(400)] string gacaja_gaubic_def, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_gaubic_expedicion, 
							[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def);

						/// <summary>
			/// Llama a DAME_DATOS_EXTRACCION_PRIOR.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_PRIOR> DAME_DATOS_EXTRACCION_PRIOR(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gaart_cod, 
				string p_gaalmnom_cod, 
				string p_lote, 
				string p_gaubic_cod, 
				decimal? p_c_uni1_extraer, 
				string p_opcion, 
				string p_emp_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				DateTime? p_galotes_min_f_cad, 
				string gaubic_criterio_extraer_caja, 
				string sga_criterio_extraer_caja, 
				string gacaja_gaubic_def, 
				string sga_gaubic_picking_cond, 
				string sga_gaubic_expedicion, 
				string sga_gacaja_ggestado_exped_perm, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_DATOS_EXTRACCION_PRIOR_VVVVVNVVVNDDVVVVVVVVVV v_dame_datos_extraccion_prior;
				try {
					v_dame_datos_extraccion_prior = Funcion.Crear<__DAME_DATOS_EXTRACCION_PRIOR_VVVVVNVVVNDDVVVVVVVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DATOS_EXTRACCION_PRIOR", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_PRIOR> v_resultado;
								try {
				v_resultado = v_dame_datos_extraccion_prior(p_transaccion, 
					p_empgrupo_cod, 
					p_gaart_cod, 
					p_gaalmnom_cod, 
					p_lote, 
					p_gaubic_cod, 
					p_c_uni1_extraer, 
					p_opcion, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					p_galotes_min_f_cad, 
					gaubic_criterio_extraer_caja, 
					sga_criterio_extraer_caja, 
					gacaja_gaubic_def, 
					sga_gaubic_picking_cond, 
					sga_gaubic_expedicion, 
					sga_gacaja_ggestado_exped_perm, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DATOS_EXTRACCION_PRIOR", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_DATOS_EXTRACCION_PRIOR_C
			 
					public interface IDAME_DATOS_EXTRACCION_PRIOR_C 
{
			string GAUBIC_COD { get; }
			string GACAJA_COD { get; }
			decimal? C_UNI1 { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_DATOS_EXTRACCION_PRIOR_C")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_PRIOR_C> __DAME_DATOS_EXTRACCION_PRIOR_C_VVVVVNVVVNDDVVVVVVVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2] string p_lote, 
							[VARCHAR2] string p_gaubic_cod, 
							[NUMBER] decimal? p_c_uni1_extraer, 
							[VARCHAR2] string p_opcion, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string gaubic_criterio_extraer_caja, 
							[VARCHAR2(400)] string sga_criterio_extraer_caja, 
							[VARCHAR2(400)] string gacaja_gaubic_def, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_gaubic_expedicion, 
							[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def);

						/// <summary>
			/// Llama a DAME_DATOS_EXTRACCION_PRIOR_C.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_PRIOR_C> DAME_DATOS_EXTRACCION_PRIOR_C(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gaart_cod, 
				string p_gaalmnom_cod, 
				string p_lote, 
				string p_gaubic_cod, 
				decimal? p_c_uni1_extraer, 
				string p_opcion, 
				string p_emp_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				DateTime? p_galotes_min_f_cad, 
				string gaubic_criterio_extraer_caja, 
				string sga_criterio_extraer_caja, 
				string gacaja_gaubic_def, 
				string sga_gaubic_picking_cond, 
				string sga_gaubic_expedicion, 
				string sga_gacaja_ggestado_exped_perm, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_DATOS_EXTRACCION_PRIOR_C_VVVVVNVVVNDDVVVVVVVVVV v_dame_datos_extraccion_prior_c;
				try {
					v_dame_datos_extraccion_prior_c = Funcion.Crear<__DAME_DATOS_EXTRACCION_PRIOR_C_VVVVVNVVVNDDVVVVVVVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DATOS_EXTRACCION_PRIOR_C", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_DATOS_EXTRACCION_PRIOR_C> v_resultado;
								try {
				v_resultado = v_dame_datos_extraccion_prior_c(p_transaccion, 
					p_empgrupo_cod, 
					p_gaart_cod, 
					p_gaalmnom_cod, 
					p_lote, 
					p_gaubic_cod, 
					p_c_uni1_extraer, 
					p_opcion, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					p_galotes_min_f_cad, 
					gaubic_criterio_extraer_caja, 
					sga_criterio_extraer_caja, 
					gacaja_gaubic_def, 
					sga_gaubic_picking_cond, 
					sga_gaubic_expedicion, 
					sga_gacaja_ggestado_exped_perm, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DATOS_EXTRACCION_PRIOR_C", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_DETALLE_BULTO
			 
					public interface IDAME_DETALLE_BULTO 
{
			string TIP_VC { get; }
			string GGALBTIP_COD { get; }
			int? N_ALBARAN { get; }
			int? N_BULTO { get; }
			string GACAJA_COD { get; }
			decimal? C_UNI1 { get; }
			decimal? C_UNI2 { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_DETALLE_BULTO")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_DETALLE_BULTO> __DAME_DETALLE_BULTO_VVVVNVNN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[VARCHAR2(8)] string p_ggalbtip_cod, 
							[NUMBER] int? p_n_albaran, 
							[NUMBER] int? p_n_bulto);

						/// <summary>
			/// Llama a DAME_DETALLE_BULTO.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_DETALLE_BULTO> DAME_DETALLE_BULTO(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				string p_ggalbtip_cod, 
				int? p_n_albaran, 
				int? p_n_bulto,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_DETALLE_BULTO_VVVVNVNN v_dame_detalle_bulto;
				try {
					v_dame_detalle_bulto = Funcion.Crear<__DAME_DETALLE_BULTO_VVVVNVNN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DETALLE_BULTO", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_DETALLE_BULTO> v_resultado;
								try {
				v_resultado = v_dame_detalle_bulto(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					p_ggalbtip_cod, 
					p_n_albaran, 
					p_n_bulto);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DETALLE_BULTO", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_DISPONIBLE_GAALM
			
			[Nombre("RF_SGA_PKG.DAME_DISPONIBLE_GAALM")]
						public delegate void __DAME_DISPONIBLE_GAALM_VVVVoNoN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[NUMBER] out decimal? p_c_dispo1, 
							[NUMBER] out decimal? p_c_dispo2);

						/// <summary>
			/// Llama a DAME_DISPONIBLE_GAALM.
						/// </summary>
			public static void DAME_DISPONIBLE_GAALM(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod, 
				string p_gaalmnom_cod, 
				out decimal? p_c_dispo1, 
				out decimal? p_c_dispo2,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_DISPONIBLE_GAALM_VVVVoNoN v_dame_disponible_gaalm;
				try {
					v_dame_disponible_gaalm = Funcion.Crear<__DAME_DISPONIBLE_GAALM_VVVVoNoN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DISPONIBLE_GAALM", ex);
								}
								try {
				v_dame_disponible_gaalm(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod, 
					p_gaalmnom_cod, 
					out p_c_dispo1, 
					out p_c_dispo2);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_DISPONIBLE_GAALM", ex);
								}
							}
			
			
			#endregion

					#region DAME_GAALMCLI
			 
					public interface IDAME_GAALMCLI 
{
			string GAALMNOM_COD { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_GAALMCLI")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_GAALMCLI> __DAME_GAALMCLI_VVN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod);

						/// <summary>
			/// Llama a DAME_GAALMCLI.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_GAALMCLI> DAME_GAALMCLI(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_GAALMCLI_VVN v_dame_gaalmcli;
				try {
					v_dame_gaalmcli = Funcion.Crear<__DAME_GAALMCLI_VVN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_GAALMCLI", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_GAALMCLI> v_resultado;
								try {
				v_resultado = v_dame_gaalmcli(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_GAALMCLI", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_GAALMNOM_TRASP
			
			[Nombre("RF_SGA_PKG.DAME_GAALMNOM_TRASP")]
						public delegate void __DAME_GAALMNOM_TRASP_VVVVNoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggalbtip_cod, 
							[NUMBER] int? p_ggclipr_cod, 
							[VARCHAR2(6)] out string p_gaalmnom_trasp, 
							[VARCHAR2] out string p_msg_error);

						/// <summary>
			/// Llama a DAME_GAALMNOM_TRASP.
						/// </summary>
			public static void DAME_GAALMNOM_TRASP(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggalbtip_cod, 
				int? p_ggclipr_cod, 
				out string p_gaalmnom_trasp, 
				out string p_msg_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_GAALMNOM_TRASP_VVVVNoVoV v_dame_gaalmnom_trasp;
				try {
					v_dame_gaalmnom_trasp = Funcion.Crear<__DAME_GAALMNOM_TRASP_VVVVNoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_GAALMNOM_TRASP", ex);
								}
								try {
				v_dame_gaalmnom_trasp(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggalbtip_cod, 
					p_ggclipr_cod, 
					out p_gaalmnom_trasp, 
					out p_msg_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_GAALMNOM_TRASP", ex);
								}
							}
			
			
			#endregion

					#region DAME_GALOTES_MIN_F_CADUCIDAD
			
			[Nombre("RF_SGA_PKG.DAME_GALOTES_MIN_F_CADUCIDAD")]
						[return: DATE]
						public delegate DateTime? __DAME_GALOTES_MIN_F_CADUCIDAD_VVVVNDVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def);

						/// <summary>
			/// Llama a DAME_GALOTES_MIN_F_CADUCIDAD.
						/// </summary>
			public static DateTime? DAME_GALOTES_MIN_F_CADUCIDAD(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_GALOTES_MIN_F_CADUCIDAD_VVVVNDVVVV v_dame_galotes_min_f_caducidad;
				try {
					v_dame_galotes_min_f_caducidad = Funcion.Crear<__DAME_GALOTES_MIN_F_CADUCIDAD_VVVVNDVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_GALOTES_MIN_F_CADUCIDAD", ex);
								}
									DateTime? v_resultado;
								try {
				v_resultado = v_dame_galotes_min_f_caducidad(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_GALOTES_MIN_F_CADUCIDAD", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_GGALBTIP_GAALMNOM_TRASP
			
			[Nombre("RF_SGA_PKG.DAME_GGALBTIP_GAALMNOM_TRASP")]
						public delegate void __DAME_GGALBTIP_GAALMNOM_TRASP_VVVVNoVoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[VARCHAR2(8)] out string p_ggalbtip_cod, 
							[VARCHAR2(6)] out string p_gaalmnom_trasp, 
							[VARCHAR2] out string p_msg_error);

						/// <summary>
			/// Llama a DAME_GGALBTIP_GAALMNOM_TRASP.
						/// </summary>
			public static void DAME_GGALBTIP_GAALMNOM_TRASP(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				out string p_ggalbtip_cod, 
				out string p_gaalmnom_trasp, 
				out string p_msg_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_GGALBTIP_GAALMNOM_TRASP_VVVVNoVoVoV v_dame_ggalbtip_gaalmnom_trasp;
				try {
					v_dame_ggalbtip_gaalmnom_trasp = Funcion.Crear<__DAME_GGALBTIP_GAALMNOM_TRASP_VVVVNoVoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_GGALBTIP_GAALMNOM_TRASP", ex);
								}
								try {
				v_dame_ggalbtip_gaalmnom_trasp(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					out p_ggalbtip_cod, 
					out p_gaalmnom_trasp, 
					out p_msg_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_GGALBTIP_GAALMNOM_TRASP", ex);
								}
							}
			
			
			#endregion

					#region DAME_LISTA_SSCC_PICKING
			 
					public interface IDAME_LISTA_SSCC_PICKING 
{
	}
			
			[Nombre("RF_SGA_PKG.DAME_LISTA_SSCC_PICKING")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICKING> __DAME_LISTA_SSCC_PICKING_VVVVVNVNDDVVVVVVVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(20)] string p_lote, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[NUMBER(13, 4)] decimal? p_c_uni1, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_conf_picking_permite_comp, 
							[VARCHAR2(400)] string sga_gaubic_expedicion, 
							[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
							[VARCHAR2(400)] string gacaja_gaalmnom_def, 
							[VARCHAR2(400)] string picking_extraer_caja_orden, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def);

						/// <summary>
			/// Llama a DAME_LISTA_SSCC_PICKING.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICKING> DAME_LISTA_SSCC_PICKING(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod, 
				string p_lote, 
				string p_gaalmnom_cod, 
				decimal? p_c_uni1, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				DateTime? p_galotes_min_f_cad, 
				string sga_gaubic_picking_cond, 
				string sga_conf_picking_permite_comp, 
				string sga_gaubic_expedicion, 
				string sga_gacaja_ggestado_exped_perm, 
				string gacaja_gaalmnom_def, 
				string picking_extraer_caja_orden, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_LISTA_SSCC_PICKING_VVVVVNVNDDVVVVVVVVVV v_dame_lista_sscc_picking;
				try {
					v_dame_lista_sscc_picking = Funcion.Crear<__DAME_LISTA_SSCC_PICKING_VVVVVNVNDDVVVVVVVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_LISTA_SSCC_PICKING", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICKING> v_resultado;
								try {
				v_resultado = v_dame_lista_sscc_picking(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod, 
					p_lote, 
					p_gaalmnom_cod, 
					p_c_uni1, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					p_galotes_min_f_cad, 
					sga_gaubic_picking_cond, 
					sga_conf_picking_permite_comp, 
					sga_gaubic_expedicion, 
					sga_gacaja_ggestado_exped_perm, 
					gacaja_gaalmnom_def, 
					picking_extraer_caja_orden, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_LISTA_SSCC_PICKING", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_LISTA_SSCC_PICKING_P
			 
					public interface IDAME_LISTA_SSCC_PICKING_P 
{
			string GACAJA_COD { get; }
			string LOTE { get; }
			string GAALMNOM_COD { get; }
			string GAUBIC_COD { get; }
			decimal? C_UNI1 { get; }
			decimal? C_UNI2 { get; }
			string ESTADO { get; }
			string PICKING_SN { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_LISTA_SSCC_PICKING_P")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICKING_P> __DAME_LISTA_SSCC_PICKING_P_VVVVVNVNDDVVVVVVVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(20)] string p_lote, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[NUMBER(13, 4)] decimal? p_c_uni1, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_conf_picking_permite_comp, 
							[VARCHAR2(400)] string sga_gaubic_expedicion, 
							[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
							[VARCHAR2(400)] string gacaja_gaalmnom_def, 
							[VARCHAR2(400)] string picking_extraer_caja_orden, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def);

						/// <summary>
			/// Llama a DAME_LISTA_SSCC_PICKING_P.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICKING_P> DAME_LISTA_SSCC_PICKING_P(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod, 
				string p_lote, 
				string p_gaalmnom_cod, 
				decimal? p_c_uni1, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				DateTime? p_galotes_min_f_cad, 
				string sga_gaubic_picking_cond, 
				string sga_conf_picking_permite_comp, 
				string sga_gaubic_expedicion, 
				string sga_gacaja_ggestado_exped_perm, 
				string gacaja_gaalmnom_def, 
				string picking_extraer_caja_orden, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_LISTA_SSCC_PICKING_P_VVVVVNVNDDVVVVVVVVVV v_dame_lista_sscc_picking_p;
				try {
					v_dame_lista_sscc_picking_p = Funcion.Crear<__DAME_LISTA_SSCC_PICKING_P_VVVVVNVNDDVVVVVVVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_LISTA_SSCC_PICKING_P", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICKING_P> v_resultado;
								try {
				v_resultado = v_dame_lista_sscc_picking_p(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod, 
					p_lote, 
					p_gaalmnom_cod, 
					p_c_uni1, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					p_galotes_min_f_cad, 
					sga_gaubic_picking_cond, 
					sga_conf_picking_permite_comp, 
					sga_gaubic_expedicion, 
					sga_gacaja_ggestado_exped_perm, 
					gacaja_gaalmnom_def, 
					picking_extraer_caja_orden, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_LISTA_SSCC_PICKING_P", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_LISTA_SSCC_PICK_PRIOR
			 
					public interface IDAME_LISTA_SSCC_PICK_PRIOR 
{
			string GACAJA_COD { get; }
			string LOTE { get; }
			string GAALMNOM_COD { get; }
			string GAUBIC_COD { get; }
			decimal? C_UNI1 { get; }
			decimal? C_UNI2 { get; }
			string ESTADO { get; }
			string PICKING_SN { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_LISTA_SSCC_PICK_PRIOR")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICK_PRIOR> __DAME_LISTA_SSCC_PICK_PRIOR_VVVVVNVNDDVVVVVVVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(20)] string p_lote, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[NUMBER(13, 4)] decimal? p_c_uni1, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_conf_picking_permite_comp, 
							[VARCHAR2(400)] string sga_gaubic_expedicion, 
							[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
							[VARCHAR2(400)] string gacaja_gaalmnom_def, 
							[VARCHAR2(400)] string picking_extraer_caja_orden, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def);

						/// <summary>
			/// Llama a DAME_LISTA_SSCC_PICK_PRIOR.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICK_PRIOR> DAME_LISTA_SSCC_PICK_PRIOR(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod, 
				string p_lote, 
				string p_gaalmnom_cod, 
				decimal? p_c_uni1, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				DateTime? p_galotes_min_f_cad, 
				string sga_gaubic_picking_cond, 
				string sga_conf_picking_permite_comp, 
				string sga_gaubic_expedicion, 
				string sga_gacaja_ggestado_exped_perm, 
				string gacaja_gaalmnom_def, 
				string picking_extraer_caja_orden, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_LISTA_SSCC_PICK_PRIOR_VVVVVNVNDDVVVVVVVVVV v_dame_lista_sscc_pick_prior;
				try {
					v_dame_lista_sscc_pick_prior = Funcion.Crear<__DAME_LISTA_SSCC_PICK_PRIOR_VVVVVNVNDDVVVVVVVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_LISTA_SSCC_PICK_PRIOR", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICK_PRIOR> v_resultado;
								try {
				v_resultado = v_dame_lista_sscc_pick_prior(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod, 
					p_lote, 
					p_gaalmnom_cod, 
					p_c_uni1, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					p_galotes_min_f_cad, 
					sga_gaubic_picking_cond, 
					sga_conf_picking_permite_comp, 
					sga_gaubic_expedicion, 
					sga_gacaja_ggestado_exped_perm, 
					gacaja_gaalmnom_def, 
					picking_extraer_caja_orden, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_LISTA_SSCC_PICK_PRIOR", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_LISTA_SSCC_PICK_PRIOR_C
			 
					public interface IDAME_LISTA_SSCC_PICK_PRIOR_C 
{
			string GACAJA_COD { get; }
			string LOTE { get; }
			string GAALMNOM_COD { get; }
			string GAUBIC_COD { get; }
			decimal? C_UNI1 { get; }
			decimal? C_UNI2 { get; }
			string ESTADO { get; }
			string PICKING_SN { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_LISTA_SSCC_PICK_PRIOR_C")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICK_PRIOR_C> __DAME_LISTA_SSCC_PICK_PRIOR_C_VVVVVNVNDDVVVVVVVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(20)] string p_lote, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[NUMBER(13, 4)] decimal? p_c_uni1, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_conf_picking_permite_comp, 
							[VARCHAR2(400)] string sga_gaubic_expedicion, 
							[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
							[VARCHAR2(400)] string gacaja_gaalmnom_def, 
							[VARCHAR2(400)] string picking_extraer_caja_orden, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def);

						/// <summary>
			/// Llama a DAME_LISTA_SSCC_PICK_PRIOR_C.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICK_PRIOR_C> DAME_LISTA_SSCC_PICK_PRIOR_C(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod, 
				string p_lote, 
				string p_gaalmnom_cod, 
				decimal? p_c_uni1, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				DateTime? p_galotes_min_f_cad, 
				string sga_gaubic_picking_cond, 
				string sga_conf_picking_permite_comp, 
				string sga_gaubic_expedicion, 
				string sga_gacaja_ggestado_exped_perm, 
				string gacaja_gaalmnom_def, 
				string picking_extraer_caja_orden, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_LISTA_SSCC_PICK_PRIOR_C_VVVVVNVNDDVVVVVVVVVV v_dame_lista_sscc_pick_prior_c;
				try {
					v_dame_lista_sscc_pick_prior_c = Funcion.Crear<__DAME_LISTA_SSCC_PICK_PRIOR_C_VVVVVNVNDDVVVVVVVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_LISTA_SSCC_PICK_PRIOR_C", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_LISTA_SSCC_PICK_PRIOR_C> v_resultado;
								try {
				v_resultado = v_dame_lista_sscc_pick_prior_c(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod, 
					p_lote, 
					p_gaalmnom_cod, 
					p_c_uni1, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					p_galotes_min_f_cad, 
					sga_gaubic_picking_cond, 
					sga_conf_picking_permite_comp, 
					sga_gaubic_expedicion, 
					sga_gacaja_ggestado_exped_perm, 
					gacaja_gaalmnom_def, 
					picking_extraer_caja_orden, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_LISTA_SSCC_PICK_PRIOR_C", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_SGA_GACLATIP_AGRUP
			 
					public interface IDAME_SGA_GACLATIP_AGRUP 
{
			string GACLATIP_COD { get; }
			string GACLASIF_COD { get; }
			string VALOR { get; }
	}
			
			[Nombre("RF_SGA_PKG.DAME_SGA_GACLATIP_AGRUP")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_SGA_GACLATIP_AGRUP> __DAME_SGA_GACLATIP_AGRUP_VVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod);

						/// <summary>
			/// Llama a DAME_SGA_GACLATIP_AGRUP.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_SGA_GACLATIP_AGRUP> DAME_SGA_GACLATIP_AGRUP(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_SGA_GACLATIP_AGRUP_VVV v_dame_sga_gaclatip_agrup;
				try {
					v_dame_sga_gaclatip_agrup = Funcion.Crear<__DAME_SGA_GACLATIP_AGRUP_VVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_SGA_GACLATIP_AGRUP", ex);
								}
									System.Collections.Generic.IEnumerable<IDAME_SGA_GACLATIP_AGRUP> v_resultado;
								try {
				v_resultado = v_dame_sga_gaclatip_agrup(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_SGA_GACLATIP_AGRUP", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_UBICACION_CAJA
			
			[Nombre("RF_SGA_PKG.DAME_UBICACION_CAJA")]
						public delegate void __DAME_UBICACION_CAJA_VVoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2(6)] out string p_gaalmnom_cod, 
							[VARCHAR2(10)] out string p_gaubic_cod);

						/// <summary>
			/// Llama a DAME_UBICACION_CAJA.
						/// </summary>
			public static void DAME_UBICACION_CAJA(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gacaja_cod, 
				out string p_gaalmnom_cod, 
				out string p_gaubic_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_UBICACION_CAJA_VVoVoV v_dame_ubicacion_caja;
				try {
					v_dame_ubicacion_caja = Funcion.Crear<__DAME_UBICACION_CAJA_VVoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_UBICACION_CAJA", ex);
								}
								try {
				v_dame_ubicacion_caja(p_transaccion, 
					p_empgrupo_cod, 
					p_gacaja_cod, 
					out p_gaalmnom_cod, 
					out p_gaubic_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_UBICACION_CAJA", ex);
								}
							}
			
			
			#endregion

					#region DAME_ULTIMO_BULTO
			
			[Nombre("RF_SGA_PKG.DAME_ULTIMO_BULTO")]
						public delegate void __DAME_ULTIMO_BULTO_VVVVNVNoVoN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[VARCHAR2(8)] string p_ggalbtip_cod, 
							[NUMBER] int? p_n_albaran, 
							[VARCHAR2(4)] out string p_gvpalletip_cod, 
							[NUMBER] out int? p_n_bulto);

						/// <summary>
			/// Llama a DAME_ULTIMO_BULTO.
						/// </summary>
			public static void DAME_ULTIMO_BULTO(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				string p_ggalbtip_cod, 
				int? p_n_albaran, 
				out string p_gvpalletip_cod, 
				out int? p_n_bulto,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_ULTIMO_BULTO_VVVVNVNoVoN v_dame_ultimo_bulto;
				try {
					v_dame_ultimo_bulto = Funcion.Crear<__DAME_ULTIMO_BULTO_VVVVNVNoVoN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_ULTIMO_BULTO", ex);
								}
								try {
				v_dame_ultimo_bulto(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					p_ggalbtip_cod, 
					p_n_albaran, 
					out p_gvpalletip_cod, 
					out p_n_bulto);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DAME_ULTIMO_BULTO", ex);
								}
							}
			
			
			#endregion

					#region DATOS_CAJA
			 
					public interface IDATOS_CAJA 
{
			string COD { get; }
			string GAART_COD { get; }
			string GVPALLETIP_COD { get; }
			string GAALMNOM_ACT { get; }
			string GAUBIC_ACT { get; }
			string LOTE { get; }
			decimal? CANTIDAD1 { get; }
			decimal? CANTIDAD2 { get; }
	}
			
			[Nombre("RF_SGA_PKG.DATOS_CAJA")]
						public delegate System.Collections.Generic.IEnumerable<IDATOS_CAJA> __DATOS_CAJA_VV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_cod);

						/// <summary>
			/// Llama a DATOS_CAJA.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDATOS_CAJA> DATOS_CAJA(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DATOS_CAJA_VV v_datos_caja;
				try {
					v_datos_caja = Funcion.Crear<__DATOS_CAJA_VV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DATOS_CAJA", ex);
								}
									System.Collections.Generic.IEnumerable<IDATOS_CAJA> v_resultado;
								try {
				v_resultado = v_datos_caja(p_transaccion, 
					p_empgrupo_cod, 
					p_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DATOS_CAJA", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region DIME_ESTA_EN_EXPEDICION_SN
			
			[Nombre("RF_SGA_PKG.DIME_ESTA_EN_EXPEDICION_SN")]
						[return: VARCHAR2]
						public delegate string __DIME_ESTA_EN_EXPEDICION_SN_VVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gacaja_cod);

						/// <summary>
			/// Llama a DIME_ESTA_EN_EXPEDICION_SN.
						/// </summary>
			public static string DIME_ESTA_EN_EXPEDICION_SN(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gacaja_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DIME_ESTA_EN_EXPEDICION_SN_VVV v_dime_esta_en_expedicion_sn;
				try {
					v_dime_esta_en_expedicion_sn = Funcion.Crear<__DIME_ESTA_EN_EXPEDICION_SN_VVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DIME_ESTA_EN_EXPEDICION_SN", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_dime_esta_en_expedicion_sn(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gacaja_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.DIME_ESTA_EN_EXPEDICION_SN", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region ELIMINA_CAJA_ALBARAN
			
			[Nombre("RF_SGA_PKG.ELIMINA_CAJA_ALBARAN")]
						public delegate void __ELIMINA_CAJA_ALBARAN_VVVVNVoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggalbtip_cod, 
							[NUMBER] int? p_n_albaran, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a ELIMINA_CAJA_ALBARAN.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void ELIMINA_CAJA_ALBARAN(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggalbtip_cod, 
				int? p_n_albaran, 
				string p_gacaja_cod, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__ELIMINA_CAJA_ALBARAN_VVVVNVoVoV v_elimina_caja_albaran;
				try {
					v_elimina_caja_albaran = Funcion.Crear<__ELIMINA_CAJA_ALBARAN_VVVVNVoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.ELIMINA_CAJA_ALBARAN", ex);
								}
								try {
				v_elimina_caja_albaran(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggalbtip_cod, 
					p_n_albaran, 
					p_gacaja_cod, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.ELIMINA_CAJA_ALBARAN", ex);
								}
							}
			
							/// <summary>
				/// Llama a ELIMINA_CAJA_ALBARAN y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void ELIMINA_CAJA_ALBARAN(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[VARCHAR2(8)] string p_ggalbtip_cod, 
					[NUMBER] int? p_n_albaran, 
					[VARCHAR2(20)] string p_gacaja_cod, 
					[VARCHAR2] out string p_mensaje_info)
				{
					
					ELIMINA_CAJA_ALBARAN(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_tip_vc, 
						p_ggalbtip_cod, 
						p_n_albaran, 
						p_gacaja_cod, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.ELIMINA_CAJA_ALBARAN");
					
											p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region EXISTE_CAJA_ACTIVA_SN
			
			[Nombre("RF_SGA_PKG.EXISTE_CAJA_ACTIVA_SN")]
						[return: VARCHAR2]
						public delegate string __EXISTE_CAJA_ACTIVA_SN_VV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gacaja_cod);

						/// <summary>
			/// Llama a EXISTE_CAJA_ACTIVA_SN.
						/// </summary>
			public static string EXISTE_CAJA_ACTIVA_SN(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gacaja_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__EXISTE_CAJA_ACTIVA_SN_VV v_existe_caja_activa_sn;
				try {
					v_existe_caja_activa_sn = Funcion.Crear<__EXISTE_CAJA_ACTIVA_SN_VV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.EXISTE_CAJA_ACTIVA_SN", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_existe_caja_activa_sn(p_transaccion, 
					p_empgrupo_cod, 
					p_gacaja_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.EXISTE_CAJA_ACTIVA_SN", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region EXISTE_GACAJA_SN
			
			[Nombre("RF_SGA_PKG.EXISTE_GACAJA_SN")]
						[return: VARCHAR2]
						public delegate string __EXISTE_GACAJA_SN_VV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gacaja_cod);

						/// <summary>
			/// Llama a EXISTE_GACAJA_SN.
						/// </summary>
			public static string EXISTE_GACAJA_SN(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gacaja_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__EXISTE_GACAJA_SN_VV v_existe_gacaja_sn;
				try {
					v_existe_gacaja_sn = Funcion.Crear<__EXISTE_GACAJA_SN_VV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.EXISTE_GACAJA_SN", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_existe_gacaja_sn(p_transaccion, 
					p_empgrupo_cod, 
					p_gacaja_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.EXISTE_GACAJA_SN", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region EXTRAYENDO_COMPLETO_SN
			
			[Nombre("RF_SGA_PKG.EXTRAYENDO_COMPLETO_SN")]
						[return: VARCHAR2]
						public delegate string __EXTRAYENDO_COMPLETO_SN_VVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(6)] string p_gaalmnom_cod);

						/// <summary>
			/// Llama a EXTRAYENDO_COMPLETO_SN.
						/// </summary>
			public static string EXTRAYENDO_COMPLETO_SN(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gacaja_cod, 
				string p_gaart_cod, 
				string p_gaalmnom_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__EXTRAYENDO_COMPLETO_SN_VVVV v_extrayendo_completo_sn;
				try {
					v_extrayendo_completo_sn = Funcion.Crear<__EXTRAYENDO_COMPLETO_SN_VVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.EXTRAYENDO_COMPLETO_SN", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_extrayendo_completo_sn(p_transaccion, 
					p_empgrupo_cod, 
					p_gacaja_cod, 
					p_gaart_cod, 
					p_gaalmnom_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.EXTRAYENDO_COMPLETO_SN", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region EXTRAYENDO_PICKING_SN
			
			[Nombre("RF_SGA_PKG.EXTRAYENDO_PICKING_SN")]
						[return: VARCHAR2]
						public delegate string __EXTRAYENDO_PICKING_SN_VVVVNN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_gvpalletip_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2(4)] string p_gacaja_estado, 
							[NUMBER(13, 4)] decimal? p_gacajacont_c_uni1, 
							[NUMBER(13, 4)] decimal? p_c_uni1_extraer);

						/// <summary>
			/// Llama a EXTRAYENDO_PICKING_SN.
						/// </summary>
			public static string EXTRAYENDO_PICKING_SN(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gvpalletip_cod, 
				string p_gacaja_cod, 
				string p_gacaja_estado, 
				decimal? p_gacajacont_c_uni1, 
				decimal? p_c_uni1_extraer,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__EXTRAYENDO_PICKING_SN_VVVVNN v_extrayendo_picking_sn;
				try {
					v_extrayendo_picking_sn = Funcion.Crear<__EXTRAYENDO_PICKING_SN_VVVVNN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.EXTRAYENDO_PICKING_SN", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_extrayendo_picking_sn(p_transaccion, 
					p_empgrupo_cod, 
					p_gvpalletip_cod, 
					p_gacaja_cod, 
					p_gacaja_estado, 
					p_gacajacont_c_uni1, 
					p_c_uni1_extraer);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.EXTRAYENDO_PICKING_SN", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region FIN_GGPEDLIN_CONFIRMA_CAJA
			
			[Nombre("RF_SGA_PKG.FIN_GGPEDLIN_CONFIRMA_CAJA")]
						public delegate void __FIN_GGPEDLIN_CONFIRMA_CAJA_VVVVNoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggalbtip_cod, 
							[NUMBER] int? p_n_albaran, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a FIN_GGPEDLIN_CONFIRMA_CAJA.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void FIN_GGPEDLIN_CONFIRMA_CAJA(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggalbtip_cod, 
				int? p_n_albaran, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__FIN_GGPEDLIN_CONFIRMA_CAJA_VVVVNoV v_fin_ggpedlin_confirma_caja;
				try {
					v_fin_ggpedlin_confirma_caja = Funcion.Crear<__FIN_GGPEDLIN_CONFIRMA_CAJA_VVVVNoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.FIN_GGPEDLIN_CONFIRMA_CAJA", ex);
								}
								try {
				v_fin_ggpedlin_confirma_caja(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggalbtip_cod, 
					p_n_albaran, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.FIN_GGPEDLIN_CONFIRMA_CAJA", ex);
								}
							}
			
							/// <summary>
				/// Llama a FIN_GGPEDLIN_CONFIRMA_CAJA y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void FIN_GGPEDLIN_CONFIRMA_CAJA(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[VARCHAR2(8)] string p_ggalbtip_cod, 
					[NUMBER] int? p_n_albaran)
				{
					
					FIN_GGPEDLIN_CONFIRMA_CAJA(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_tip_vc, 
						p_ggalbtip_cod, 
						p_n_albaran,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.FIN_GGPEDLIN_CONFIRMA_CAJA");
					
										
									}	
			
			#endregion

					#region GACAJAINVEN_DAME_DATOS_INVEN
			
			[Nombre("RF_SGA_PKG.GACAJAINVEN_DAME_DATOS_INVEN")]
						public delegate void __GACAJAINVEN_DAME_DATOS_INVEN_VDVVioVioVioVioVoVoNoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(30)] string p_usrnom_cod, 
							[DATE] DateTime? p_fecha, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2(20)] ref string p_gaart_cod, 
							[VARCHAR2(20)] ref string p_lote, 
							[VARCHAR2(6)] ref string p_gaalmnom_cod, 
							[VARCHAR2(10)] ref string p_gaubic_cod, 
							[VARCHAR2(4)] out string p_gvpalletip_cod, 
							[NUMBER(13, 4)] out decimal? p_c_uni1, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a GACAJAINVEN_DAME_DATOS_INVEN.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void GACAJAINVEN_DAME_DATOS_INVEN(
				System.Data.IDbTransaction p_transaccion, 
				string p_usrnom_cod, 
				DateTime? p_fecha, 
				string p_empgrupo_cod, 
				string p_gacaja_cod, 
				ref string p_gaart_cod, 
				ref string p_lote, 
				ref string p_gaalmnom_cod, 
				ref string p_gaubic_cod, 
				out string p_gvpalletip_cod, 
				out decimal? p_c_uni1, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__GACAJAINVEN_DAME_DATOS_INVEN_VDVVioVioVioVioVoVoNoVoV v_gacajainven_dame_datos_inven;
				try {
					v_gacajainven_dame_datos_inven = Funcion.Crear<__GACAJAINVEN_DAME_DATOS_INVEN_VDVVioVioVioVioVoVoNoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GACAJAINVEN_DAME_DATOS_INVEN", ex);
								}
								try {
				v_gacajainven_dame_datos_inven(p_transaccion, 
					p_usrnom_cod, 
					p_fecha, 
					p_empgrupo_cod, 
					p_gacaja_cod, 
					ref p_gaart_cod, 
					ref p_lote, 
					ref p_gaalmnom_cod, 
					ref p_gaubic_cod, 
					out p_gvpalletip_cod, 
					out p_c_uni1, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GACAJAINVEN_DAME_DATOS_INVEN", ex);
								}
							}
			
							/// <summary>
				/// Llama a GACAJAINVEN_DAME_DATOS_INVEN y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void GACAJAINVEN_DAME_DATOS_INVEN(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(30)] string p_usrnom_cod, 
					[DATE] DateTime? p_fecha, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(20)] string p_gacaja_cod, 
					[VARCHAR2(20)] ref string p_gaart_cod, 
					[VARCHAR2(20)] ref string p_lote, 
					[VARCHAR2(6)] ref string p_gaalmnom_cod, 
					[VARCHAR2(10)] ref string p_gaubic_cod, 
					[VARCHAR2(4)] out string p_gvpalletip_cod, 
					[NUMBER(13, 4)] out decimal? p_c_uni1, 
					[VARCHAR2] out string p_mensaje_info)
				{
											var v_copia_p_gaart_cod = p_gaart_cod;
				    						var v_copia_p_lote = p_lote;
				    						var v_copia_p_gaalmnom_cod = p_gaalmnom_cod;
				    						var v_copia_p_gaubic_cod = p_gaubic_cod;
				    
					GACAJAINVEN_DAME_DATOS_INVEN(p_transaccion, 
						p_usrnom_cod, 
						p_fecha, 
						p_empgrupo_cod, 
						p_gacaja_cod, 
						ref v_copia_p_gaart_cod, 
						ref v_copia_p_lote, 
						ref v_copia_p_gaalmnom_cod, 
						ref v_copia_p_gaubic_cod, 
						out var v_copia_p_gvpalletip_cod, 
						out var v_copia_p_c_uni1, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.GACAJAINVEN_DAME_DATOS_INVEN");
					
											p_gaart_cod = v_copia_p_gaart_cod;
				    						p_lote = v_copia_p_lote;
				    						p_gaalmnom_cod = v_copia_p_gaalmnom_cod;
				    						p_gaubic_cod = v_copia_p_gaubic_cod;
				    						p_gvpalletip_cod = v_copia_p_gvpalletip_cod;
				    						p_c_uni1 = v_copia_p_c_uni1;
				    						p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region GACAJAINVEN_MODIF_DATOS_INVEN
			
			[Nombre("RF_SGA_PKG.GACAJAINVEN_MODIF_DATOS_INVEN")]
						public delegate void __GACAJAINVEN_MODIF_DATOS_INVEN_VDVVVVVVVNoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(30)] string p_usrnom_cod, 
							[DATE] DateTime? p_fecha, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(20)] string p_lote, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2(10)] string p_gaubic_cod, 
							[VARCHAR2(10)] string p_gaubic_des, 
							[NUMBER(13, 4)] decimal? p_c_inv1, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a GACAJAINVEN_MODIF_DATOS_INVEN.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void GACAJAINVEN_MODIF_DATOS_INVEN(
				System.Data.IDbTransaction p_transaccion, 
				string p_usrnom_cod, 
				DateTime? p_fecha, 
				string p_empgrupo_cod, 
				string p_gacaja_cod, 
				string p_gaart_cod, 
				string p_lote, 
				string p_gaalmnom_cod, 
				string p_gaubic_cod, 
				string p_gaubic_des, 
				decimal? p_c_inv1, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__GACAJAINVEN_MODIF_DATOS_INVEN_VDVVVVVVVNoVoV v_gacajainven_modif_datos_inven;
				try {
					v_gacajainven_modif_datos_inven = Funcion.Crear<__GACAJAINVEN_MODIF_DATOS_INVEN_VDVVVVVVVNoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GACAJAINVEN_MODIF_DATOS_INVEN", ex);
								}
								try {
				v_gacajainven_modif_datos_inven(p_transaccion, 
					p_usrnom_cod, 
					p_fecha, 
					p_empgrupo_cod, 
					p_gacaja_cod, 
					p_gaart_cod, 
					p_lote, 
					p_gaalmnom_cod, 
					p_gaubic_cod, 
					p_gaubic_des, 
					p_c_inv1, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GACAJAINVEN_MODIF_DATOS_INVEN", ex);
								}
							}
			
							/// <summary>
				/// Llama a GACAJAINVEN_MODIF_DATOS_INVEN y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void GACAJAINVEN_MODIF_DATOS_INVEN(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(30)] string p_usrnom_cod, 
					[DATE] DateTime? p_fecha, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(20)] string p_gacaja_cod, 
					[VARCHAR2(20)] string p_gaart_cod, 
					[VARCHAR2(20)] string p_lote, 
					[VARCHAR2(6)] string p_gaalmnom_cod, 
					[VARCHAR2(10)] string p_gaubic_cod, 
					[VARCHAR2(10)] string p_gaubic_des, 
					[NUMBER(13, 4)] decimal? p_c_inv1, 
					[VARCHAR2] out string p_mensaje_info)
				{
					
					GACAJAINVEN_MODIF_DATOS_INVEN(p_transaccion, 
						p_usrnom_cod, 
						p_fecha, 
						p_empgrupo_cod, 
						p_gacaja_cod, 
						p_gaart_cod, 
						p_lote, 
						p_gaalmnom_cod, 
						p_gaubic_cod, 
						p_gaubic_des, 
						p_c_inv1, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.GACAJAINVEN_MODIF_DATOS_INVEN");
					
											p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region GACAJA_CODIGO_CORRECTO_SN
			
			[Nombre("RF_SGA_PKG.GACAJA_CODIGO_CORRECTO_SN")]
						[return: VARCHAR2]
						public delegate string __GACAJA_CODIGO_CORRECTO_SN_VVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(4)] string p_gvpalletip_cod, 
							[VARCHAR2(20)] string p_gacaja_cod);

						/// <summary>
			/// Llama a GACAJA_CODIGO_CORRECTO_SN.
						/// </summary>
			public static string GACAJA_CODIGO_CORRECTO_SN(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gvpalletip_cod, 
				string p_gacaja_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__GACAJA_CODIGO_CORRECTO_SN_VVVV v_gacaja_codigo_correcto_sn;
				try {
					v_gacaja_codigo_correcto_sn = Funcion.Crear<__GACAJA_CODIGO_CORRECTO_SN_VVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GACAJA_CODIGO_CORRECTO_SN", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_gacaja_codigo_correcto_sn(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gvpalletip_cod, 
					p_gacaja_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GACAJA_CODIGO_CORRECTO_SN", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region GAUBIC_PROPONER
			
			[Nombre("RF_SGA_PKG.GAUBIC_PROPONER")]
						[return: VARCHAR2]
						public delegate string __GAUBIC_PROPONER_VVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2] string p_gaubic_cond, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2] string p_opcion);

						/// <summary>
			/// Llama a GAUBIC_PROPONER.
						/// </summary>
			public static string GAUBIC_PROPONER(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gacaja_cod, 
				string p_gaubic_cond, 
				string p_gaalmnom_cod, 
				string p_opcion,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__GAUBIC_PROPONER_VVVVV v_gaubic_proponer;
				try {
					v_gaubic_proponer = Funcion.Crear<__GAUBIC_PROPONER_VVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GAUBIC_PROPONER", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_gaubic_proponer(p_transaccion, 
					p_empgrupo_cod, 
					p_gacaja_cod, 
					p_gaubic_cond, 
					p_gaalmnom_cod, 
					p_opcion);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GAUBIC_PROPONER", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region GGPEDLCAJA_CONFIRMA
			
			[Nombre("RF_SGA_PKG.GGPEDLCAJA_CONFIRMA")]
						public delegate void __GGPEDLCAJA_CONFIRMA_VVVVNioVioNoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[VARCHAR2(8)] ref string p_ggalbtip_cod, 
							[NUMBER] ref int? p_n_albaran, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a GGPEDLCAJA_CONFIRMA.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void GGPEDLCAJA_CONFIRMA(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				ref string p_ggalbtip_cod, 
				ref int? p_n_albaran, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__GGPEDLCAJA_CONFIRMA_VVVVNioVioNoVoV v_ggpedlcaja_confirma;
				try {
					v_ggpedlcaja_confirma = Funcion.Crear<__GGPEDLCAJA_CONFIRMA_VVVVNioVioNoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GGPEDLCAJA_CONFIRMA", ex);
								}
								try {
				v_ggpedlcaja_confirma(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					ref p_ggalbtip_cod, 
					ref p_n_albaran, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GGPEDLCAJA_CONFIRMA", ex);
								}
							}
			
							/// <summary>
				/// Llama a GGPEDLCAJA_CONFIRMA y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void GGPEDLCAJA_CONFIRMA(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[VARCHAR2(8)] string p_ggpedtip_cod, 
					[NUMBER] int? p_n_pedido, 
					[VARCHAR2(8)] ref string p_ggalbtip_cod, 
					[NUMBER] ref int? p_n_albaran, 
					[VARCHAR2] out string p_mensaje_info)
				{
											var v_copia_p_ggalbtip_cod = p_ggalbtip_cod;
				    						var v_copia_p_n_albaran = p_n_albaran;
				    
					GGPEDLCAJA_CONFIRMA(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_tip_vc, 
						p_ggpedtip_cod, 
						p_n_pedido, 
						ref v_copia_p_ggalbtip_cod, 
						ref v_copia_p_n_albaran, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.GGPEDLCAJA_CONFIRMA");
					
											p_ggalbtip_cod = v_copia_p_ggalbtip_cod;
				    						p_n_albaran = v_copia_p_n_albaran;
				    						p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region GRABAR_MOVI_TRASP
			
			[Nombre("RF_SGA_PKG.GRABAR_MOVI_TRASP")]
						public delegate void __GRABAR_MOVI_TRASP_VVVVVVVVDVoRoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2(4)] string p_gamovtip_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(6)] string p_gaalmnom_ori, 
							[VARCHAR2(10)] string p_gaubic_ori, 
							[VARCHAR2(6)] string p_gaalmnom_des, 
							[VARCHAR2(10)] string p_gaubic_des, 
							[DATE] DateTime? p_f_mov, 
							[VARCHAR2] string p_opcion, 
							[ROWID] out string p_rowid, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a GRABAR_MOVI_TRASP.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void GRABAR_MOVI_TRASP(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gacaja_cod, 
				string p_gamovtip_cod, 
				string p_emp_cod, 
				string p_gaalmnom_ori, 
				string p_gaubic_ori, 
				string p_gaalmnom_des, 
				string p_gaubic_des, 
				DateTime? p_f_mov, 
				string p_opcion, 
				out string p_rowid, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__GRABAR_MOVI_TRASP_VVVVVVVVDVoRoVoV v_grabar_movi_trasp;
				try {
					v_grabar_movi_trasp = Funcion.Crear<__GRABAR_MOVI_TRASP_VVVVVVVVDVoRoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GRABAR_MOVI_TRASP", ex);
								}
								try {
				v_grabar_movi_trasp(p_transaccion, 
					p_empgrupo_cod, 
					p_gacaja_cod, 
					p_gamovtip_cod, 
					p_emp_cod, 
					p_gaalmnom_ori, 
					p_gaubic_ori, 
					p_gaalmnom_des, 
					p_gaubic_des, 
					p_f_mov, 
					p_opcion, 
					out p_rowid, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.GRABAR_MOVI_TRASP", ex);
								}
							}
			
							/// <summary>
				/// Llama a GRABAR_MOVI_TRASP y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void GRABAR_MOVI_TRASP(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(20)] string p_gacaja_cod, 
					[VARCHAR2(4)] string p_gamovtip_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(6)] string p_gaalmnom_ori, 
					[VARCHAR2(10)] string p_gaubic_ori, 
					[VARCHAR2(6)] string p_gaalmnom_des, 
					[VARCHAR2(10)] string p_gaubic_des, 
					[DATE] DateTime? p_f_mov, 
					[VARCHAR2] string p_opcion, 
					[ROWID] out string p_rowid, 
					[VARCHAR2] out string p_mensaje_info)
				{
					
					GRABAR_MOVI_TRASP(p_transaccion, 
						p_empgrupo_cod, 
						p_gacaja_cod, 
						p_gamovtip_cod, 
						p_emp_cod, 
						p_gaalmnom_ori, 
						p_gaubic_ori, 
						p_gaalmnom_des, 
						p_gaubic_des, 
						p_f_mov, 
						p_opcion, 
						out var v_copia_p_rowid, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.GRABAR_MOVI_TRASP");
					
											p_rowid = v_copia_p_rowid;
				    						p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region IDENTIFICA_TIPO_DATO
			
			[Nombre("RF_SGA_PKG.IDENTIFICA_TIPO_DATO")]
						[return: VARCHAR2]
						public delegate string __IDENTIFICA_TIPO_DATO_VVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2(20)] string p_dato);

						/// <summary>
			/// Llama a IDENTIFICA_TIPO_DATO.
						/// </summary>
			public static string IDENTIFICA_TIPO_DATO(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gaalmnom_cod, 
				string p_dato,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__IDENTIFICA_TIPO_DATO_VVV v_identifica_tipo_dato;
				try {
					v_identifica_tipo_dato = Funcion.Crear<__IDENTIFICA_TIPO_DATO_VVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.IDENTIFICA_TIPO_DATO", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_identifica_tipo_dato(p_transaccion, 
					p_empgrupo_cod, 
					p_gaalmnom_cod, 
					p_dato);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.IDENTIFICA_TIPO_DATO", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region PON_GGPEDLIN_HIST_S
			
			[Nombre("RF_SGA_PKG.PON_GGPEDLIN_HIST_S")]
						public delegate void __PON_GGPEDLIN_HIST_S_VVVVNN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[NUMBER] int? p_n_lin);

						/// <summary>
			/// Llama a PON_GGPEDLIN_HIST_S.
						/// </summary>
			public static void PON_GGPEDLIN_HIST_S(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				int? p_n_lin,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__PON_GGPEDLIN_HIST_S_VVVVNN v_pon_ggpedlin_hist_s;
				try {
					v_pon_ggpedlin_hist_s = Funcion.Crear<__PON_GGPEDLIN_HIST_S_VVVVNN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.PON_GGPEDLIN_HIST_S", ex);
								}
								try {
				v_pon_ggpedlin_hist_s(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					p_n_lin);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.PON_GGPEDLIN_HIST_S", ex);
								}
							}
			
			
			#endregion

					#region SALIR_DE_LISTA_PREPARACION
			
			[Nombre("RF_SGA_PKG.SALIR_DE_LISTA_PREPARACION")]
						public delegate void __SALIR_DE_LISTA_PREPARACION_VVVVNVoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_gglptip_cod, 
							[NUMBER] int? p_n_lp, 
							[VARCHAR2] string p_respuesta_sn, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a SALIR_DE_LISTA_PREPARACION.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void SALIR_DE_LISTA_PREPARACION(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_gglptip_cod, 
				int? p_n_lp, 
				string p_respuesta_sn, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SALIR_DE_LISTA_PREPARACION_VVVVNVoVoV v_salir_de_lista_preparacion;
				try {
					v_salir_de_lista_preparacion = Funcion.Crear<__SALIR_DE_LISTA_PREPARACION_VVVVNVoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SALIR_DE_LISTA_PREPARACION", ex);
								}
								try {
				v_salir_de_lista_preparacion(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_gglptip_cod, 
					p_n_lp, 
					p_respuesta_sn, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SALIR_DE_LISTA_PREPARACION", ex);
								}
							}
			
							/// <summary>
				/// Llama a SALIR_DE_LISTA_PREPARACION y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void SALIR_DE_LISTA_PREPARACION(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[VARCHAR2(8)] string p_gglptip_cod, 
					[NUMBER] int? p_n_lp, 
					[VARCHAR2] string p_respuesta_sn, 
					[VARCHAR2] out string p_mensaje_info)
				{
					
					SALIR_DE_LISTA_PREPARACION(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_tip_vc, 
						p_gglptip_cod, 
						p_n_lp, 
						p_respuesta_sn, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.SALIR_DE_LISTA_PREPARACION");
					
											p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region SGA_CANTIDAD_FALTA_EN_CAJA
			
			[Nombre("RF_SGA_PKG.SGA_CANTIDAD_FALTA_EN_CAJA")]
						public delegate void __SGA_CANTIDAD_FALTA_EN_CAJA_VVVoNoNoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[NUMBER] out decimal? p_c_uni1, 
							[NUMBER] out decimal? p_c_uni2, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a SGA_CANTIDAD_FALTA_EN_CAJA.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void SGA_CANTIDAD_FALTA_EN_CAJA(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gacaja_cod, 
				out decimal? p_c_uni1, 
				out decimal? p_c_uni2, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_CANTIDAD_FALTA_EN_CAJA_VVVoNoNoV v_sga_cantidad_falta_en_caja;
				try {
					v_sga_cantidad_falta_en_caja = Funcion.Crear<__SGA_CANTIDAD_FALTA_EN_CAJA_VVVoNoNoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_CANTIDAD_FALTA_EN_CAJA", ex);
								}
								try {
				v_sga_cantidad_falta_en_caja(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gacaja_cod, 
					out p_c_uni1, 
					out p_c_uni2, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_CANTIDAD_FALTA_EN_CAJA", ex);
								}
							}
			
							/// <summary>
				/// Llama a SGA_CANTIDAD_FALTA_EN_CAJA y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void SGA_CANTIDAD_FALTA_EN_CAJA(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(20)] string p_gacaja_cod, 
					[NUMBER] out decimal? p_c_uni1, 
					[NUMBER] out decimal? p_c_uni2)
				{
					
					SGA_CANTIDAD_FALTA_EN_CAJA(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_gacaja_cod, 
						out var v_copia_p_c_uni1, 
						out var v_copia_p_c_uni2,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.SGA_CANTIDAD_FALTA_EN_CAJA");
					
											p_c_uni1 = v_copia_p_c_uni1;
				    						p_c_uni2 = v_copia_p_c_uni2;
				    					
									}	
			
			#endregion

					#region SGA_DAME_BULTOS_PDTES_IMP
			 
					public interface ISGA_DAME_BULTOS_PDTES_IMP 
{
			string GGALBTIP_COD { get; }
			int? N_ALBARAN { get; }
			int? N_BULTO { get; }
	}
			
			[Nombre("RF_SGA_PKG.SGA_DAME_BULTOS_PDTES_IMP")]
						public delegate System.Collections.Generic.IEnumerable<ISGA_DAME_BULTOS_PDTES_IMP> __SGA_DAME_BULTOS_PDTES_IMP_VVVVN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido);

						/// <summary>
			/// Llama a SGA_DAME_BULTOS_PDTES_IMP.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<ISGA_DAME_BULTOS_PDTES_IMP> SGA_DAME_BULTOS_PDTES_IMP(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_DAME_BULTOS_PDTES_IMP_VVVVN v_sga_dame_bultos_pdtes_imp;
				try {
					v_sga_dame_bultos_pdtes_imp = Funcion.Crear<__SGA_DAME_BULTOS_PDTES_IMP_VVVVN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_BULTOS_PDTES_IMP", ex);
								}
									System.Collections.Generic.IEnumerable<ISGA_DAME_BULTOS_PDTES_IMP> v_resultado;
								try {
				v_resultado = v_sga_dame_bultos_pdtes_imp(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_BULTOS_PDTES_IMP", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region SGA_DAME_CAJA_PICKING
			
			[Nombre("RF_SGA_PKG.SGA_DAME_CAJA_PICKING")]
						public delegate void __SGA_DAME_CAJA_PICKING_VVVVNDVVDVVVVVVVVVVoVoVoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_ped, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2(20)] string p_lote, 
							[DATE] DateTime? p_galotes_min_f_cad, 
							[VARCHAR2(400)] string sga_gaubic_picking_cond, 
							[VARCHAR2(400)] string sga_conf_picking_permite_comp, 
							[VARCHAR2(400)] string sga_gaubic_expedicion, 
							[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
							[VARCHAR2(400)] string gacaja_gaalmnom_def, 
							[VARCHAR2(400)] string picking_extraer_caja_orden, 
							[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
							[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
							[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
							[VARCHAR2(400)] string sga_extraer_f_cad_dias_def, 
							[VARCHAR2(20)] out string p_gacaja_cod, 
							[VARCHAR2(10)] out string p_gaubic_cod, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a SGA_DAME_CAJA_PICKING.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void SGA_DAME_CAJA_PICKING(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				DateTime? p_f_ped, 
				string p_gaalmnom_cod, 
				string p_lote, 
				DateTime? p_galotes_min_f_cad, 
				string sga_gaubic_picking_cond, 
				string sga_conf_picking_permite_comp, 
				string sga_gaubic_expedicion, 
				string sga_gacaja_ggestado_exped_perm, 
				string gacaja_gaalmnom_def, 
				string picking_extraer_caja_orden, 
				string sga_extraer_f_cad_tratar, 
				string sga_extraer_f_cad_gaclatip_cod, 
				string sga_extraer_f_cad_def_gaclatip, 
				string sga_extraer_f_cad_dias_def, 
				out string p_gacaja_cod, 
				out string p_gaubic_cod, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_DAME_CAJA_PICKING_VVVVNDVVDVVVVVVVVVVoVoVoVoV v_sga_dame_caja_picking;
				try {
					v_sga_dame_caja_picking = Funcion.Crear<__SGA_DAME_CAJA_PICKING_VVVVNDVVDVVVVVVVVVVoVoVoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_CAJA_PICKING", ex);
								}
								try {
				v_sga_dame_caja_picking(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_f_ped, 
					p_gaalmnom_cod, 
					p_lote, 
					p_galotes_min_f_cad, 
					sga_gaubic_picking_cond, 
					sga_conf_picking_permite_comp, 
					sga_gaubic_expedicion, 
					sga_gacaja_ggestado_exped_perm, 
					gacaja_gaalmnom_def, 
					picking_extraer_caja_orden, 
					sga_extraer_f_cad_tratar, 
					sga_extraer_f_cad_gaclatip_cod, 
					sga_extraer_f_cad_def_gaclatip, 
					sga_extraer_f_cad_dias_def, 
					out p_gacaja_cod, 
					out p_gaubic_cod, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_CAJA_PICKING", ex);
								}
							}
			
							/// <summary>
				/// Llama a SGA_DAME_CAJA_PICKING y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void SGA_DAME_CAJA_PICKING(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(20)] string p_gaart_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[NUMBER] int? p_ggclipr_cod, 
					[DATE] DateTime? p_f_ped, 
					[VARCHAR2(6)] string p_gaalmnom_cod, 
					[VARCHAR2(20)] string p_lote, 
					[DATE] DateTime? p_galotes_min_f_cad, 
					[VARCHAR2(400)] string sga_gaubic_picking_cond, 
					[VARCHAR2(400)] string sga_conf_picking_permite_comp, 
					[VARCHAR2(400)] string sga_gaubic_expedicion, 
					[VARCHAR2(400)] string sga_gacaja_ggestado_exped_perm, 
					[VARCHAR2(400)] string gacaja_gaalmnom_def, 
					[VARCHAR2(400)] string picking_extraer_caja_orden, 
					[VARCHAR2(400)] string sga_extraer_f_cad_tratar, 
					[VARCHAR2(400)] string sga_extraer_f_cad_gaclatip_cod, 
					[VARCHAR2(400)] string sga_extraer_f_cad_def_gaclatip, 
					[VARCHAR2(400)] string sga_extraer_f_cad_dias_def, 
					[VARCHAR2(20)] out string p_gacaja_cod, 
					[VARCHAR2(10)] out string p_gaubic_cod, 
					[VARCHAR2] out string p_mensaje_info)
				{
					
					SGA_DAME_CAJA_PICKING(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_gaart_cod, 
						p_tip_vc, 
						p_ggclipr_cod, 
						p_f_ped, 
						p_gaalmnom_cod, 
						p_lote, 
						p_galotes_min_f_cad, 
						sga_gaubic_picking_cond, 
						sga_conf_picking_permite_comp, 
						sga_gaubic_expedicion, 
						sga_gacaja_ggestado_exped_perm, 
						gacaja_gaalmnom_def, 
						picking_extraer_caja_orden, 
						sga_extraer_f_cad_tratar, 
						sga_extraer_f_cad_gaclatip_cod, 
						sga_extraer_f_cad_def_gaclatip, 
						sga_extraer_f_cad_dias_def, 
						out var v_copia_p_gacaja_cod, 
						out var v_copia_p_gaubic_cod, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.SGA_DAME_CAJA_PICKING");
					
											p_gacaja_cod = v_copia_p_gacaja_cod;
				    						p_gaubic_cod = v_copia_p_gaubic_cod;
				    						p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region SGA_DAME_GAUBIC_DEF
			
			[Nombre("RF_SGA_PKG.SGA_DAME_GAUBIC_DEF")]
						[return: VARCHAR2(10)]
						public delegate string __SGA_DAME_GAUBIC_DEF_VV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod);

						/// <summary>
			/// Llama a SGA_DAME_GAUBIC_DEF.
						/// </summary>
			public static string SGA_DAME_GAUBIC_DEF(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_DAME_GAUBIC_DEF_VV v_sga_dame_gaubic_def;
				try {
					v_sga_dame_gaubic_def = Funcion.Crear<__SGA_DAME_GAUBIC_DEF_VV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_GAUBIC_DEF", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_sga_dame_gaubic_def(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_GAUBIC_DEF", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region SGA_DAME_LOTE_DEF
			
			[Nombre("RF_SGA_PKG.SGA_DAME_LOTE_DEF")]
						[return: VARCHAR2]
						public delegate string __SGA_DAME_LOTE_DEF_VVVVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2] string p_opcion, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a SGA_DAME_LOTE_DEF.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static string SGA_DAME_LOTE_DEF(
				System.Data.IDbTransaction p_transaccion, 
				string p_gacaja_cod, 
				string p_empgrupo_cod, 
				string p_gaart_cod, 
				string p_opcion, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_DAME_LOTE_DEF_VVVVoV v_sga_dame_lote_def;
				try {
					v_sga_dame_lote_def = Funcion.Crear<__SGA_DAME_LOTE_DEF_VVVVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_LOTE_DEF", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_sga_dame_lote_def(p_transaccion, 
					p_gacaja_cod, 
					p_empgrupo_cod, 
					p_gaart_cod, 
					p_opcion, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_LOTE_DEF", ex);
								}
									return v_resultado;
							}
			
							/// <summary>
				/// Llama a SGA_DAME_LOTE_DEF y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static string SGA_DAME_LOTE_DEF(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(20)] string p_gacaja_cod, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(20)] string p_gaart_cod, 
					[VARCHAR2] string p_opcion)
				{
					
					var v_resultado = SGA_DAME_LOTE_DEF(p_transaccion, 
						p_gacaja_cod, 
						p_empgrupo_cod, 
						p_gaart_cod, 
						p_opcion,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.SGA_DAME_LOTE_DEF");
					
										
											return v_resultado;
									}	
			
			#endregion

					#region SGA_DAME_TIPOS_BULTO
			 
					public interface ISGA_DAME_TIPOS_BULTO 
{
			string COD { get; }
			string DESCRIP { get; }
	}
			
			[Nombre("RF_SGA_PKG.SGA_DAME_TIPOS_BULTO")]
						public delegate System.Collections.Generic.IEnumerable<ISGA_DAME_TIPOS_BULTO> __SGA_DAME_TIPOS_BULTO_V(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2] string p_cod);

						/// <summary>
			/// Llama a SGA_DAME_TIPOS_BULTO.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<ISGA_DAME_TIPOS_BULTO> SGA_DAME_TIPOS_BULTO(
				System.Data.IDbTransaction p_transaccion, 
				string p_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_DAME_TIPOS_BULTO_V v_sga_dame_tipos_bulto;
				try {
					v_sga_dame_tipos_bulto = Funcion.Crear<__SGA_DAME_TIPOS_BULTO_V>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_TIPOS_BULTO", ex);
								}
									System.Collections.Generic.IEnumerable<ISGA_DAME_TIPOS_BULTO> v_resultado;
								try {
				v_resultado = v_sga_dame_tipos_bulto(p_transaccion, 
					p_cod);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_DAME_TIPOS_BULTO", ex);
								}
									return v_resultado;
							}
			
			
			#endregion

					#region SGA_GAART_TRATA_CAJAS_SN
			
			[Nombre("RF_SGA_PKG.SGA_GAART_TRATA_CAJAS_SN")]
						[return: VARCHAR2]
						public delegate string __SGA_GAART_TRATA_CAJAS_SN_VVVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a SGA_GAART_TRATA_CAJAS_SN.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static string SGA_GAART_TRATA_CAJAS_SN(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_gaart_cod, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_GAART_TRATA_CAJAS_SN_VVVoV v_sga_gaart_trata_cajas_sn;
				try {
					v_sga_gaart_trata_cajas_sn = Funcion.Crear<__SGA_GAART_TRATA_CAJAS_SN_VVVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_GAART_TRATA_CAJAS_SN", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_sga_gaart_trata_cajas_sn(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_gaart_cod, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_GAART_TRATA_CAJAS_SN", ex);
								}
									return v_resultado;
							}
			
							/// <summary>
				/// Llama a SGA_GAART_TRATA_CAJAS_SN y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static string SGA_GAART_TRATA_CAJAS_SN(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(20)] string p_gaart_cod)
				{
					
					var v_resultado = SGA_GAART_TRATA_CAJAS_SN(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_gaart_cod,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.SGA_GAART_TRATA_CAJAS_SN");
					
										
											return v_resultado;
									}	
			
			#endregion

					#region SGA_GAUBIC_DESTINO_VALIDA
			
			[Nombre("RF_SGA_PKG.SGA_GAUBIC_DESTINO_VALIDA")]
						[return: VARCHAR2]
						public delegate string __SGA_GAUBIC_DESTINO_VALIDA_VVVVVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2(10)] string p_gaubic_cod, 
							[VARCHAR2(20)] string p_gacaja_cod, 
							[VARCHAR2] string p_opcion, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a SGA_GAUBIC_DESTINO_VALIDA.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static string SGA_GAUBIC_DESTINO_VALIDA(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_gaalmnom_cod, 
				string p_gaubic_cod, 
				string p_gacaja_cod, 
				string p_opcion, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_GAUBIC_DESTINO_VALIDA_VVVVVoV v_sga_gaubic_destino_valida;
				try {
					v_sga_gaubic_destino_valida = Funcion.Crear<__SGA_GAUBIC_DESTINO_VALIDA_VVVVVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_GAUBIC_DESTINO_VALIDA", ex);
								}
									string v_resultado;
								try {
				v_resultado = v_sga_gaubic_destino_valida(p_transaccion, 
					p_empgrupo_cod, 
					p_gaalmnom_cod, 
					p_gaubic_cod, 
					p_gacaja_cod, 
					p_opcion, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_GAUBIC_DESTINO_VALIDA", ex);
								}
									return v_resultado;
							}
			
							/// <summary>
				/// Llama a SGA_GAUBIC_DESTINO_VALIDA y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static string SGA_GAUBIC_DESTINO_VALIDA(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(6)] string p_gaalmnom_cod, 
					[VARCHAR2(10)] string p_gaubic_cod, 
					[VARCHAR2(20)] string p_gacaja_cod, 
					[VARCHAR2] string p_opcion)
				{
					
					var v_resultado = SGA_GAUBIC_DESTINO_VALIDA(p_transaccion, 
						p_empgrupo_cod, 
						p_gaalmnom_cod, 
						p_gaubic_cod, 
						p_gacaja_cod, 
						p_opcion,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.SGA_GAUBIC_DESTINO_VALIDA");
					
										
											return v_resultado;
									}	
			
			#endregion

					#region SGA_LLENA_CAJA_DESDE_RECEPCION
			
			[Nombre("RF_SGA_PKG.SGA_LLENA_CAJA_DESDE_RECEPCION")]
						public delegate void __SGA_LLENA_CAJA_DESDE_RECEPCION_VVVVNNVVVVVNNioVioNioVioVDoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(8)] string p_ggpedtip_cod, 
							[NUMBER] int? p_n_pedido, 
							[NUMBER] int? p_n_lin_ped, 
							[VARCHAR2(4)] string p_gvpalletip_cod, 
							[VARCHAR2(20)] string p_gaart_cod, 
							[VARCHAR2(20)] string p_lote, 
							[VARCHAR2(6)] string p_gaalmnom_cod, 
							[VARCHAR2(10)] string p_gaubic_cod, 
							[NUMBER(13, 4)] decimal? p_c_uni1, 
							[NUMBER(13, 4)] decimal? p_c_uni2, 
							[VARCHAR2(8)] ref string p_ggalbtip_cod, 
							[NUMBER] ref int? p_n_albaran, 
							[VARCHAR2(4)] ref string p_n_lin_alb, 
							[VARCHAR2(20)] ref string p_gacaja_cod, 
							[DATE] DateTime? p_galotes_f_cad, 
							[VARCHAR2] out string p_mensaje_info, 
							[VARCHAR2] out string p_mensaje_error);

						/// <summary>
			/// Llama a SGA_LLENA_CAJA_DESDE_RECEPCION.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versión sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void SGA_LLENA_CAJA_DESDE_RECEPCION(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				string p_ggpedtip_cod, 
				int? p_n_pedido, 
				int? p_n_lin_ped, 
				string p_gvpalletip_cod, 
				string p_gaart_cod, 
				string p_lote, 
				string p_gaalmnom_cod, 
				string p_gaubic_cod, 
				decimal? p_c_uni1, 
				decimal? p_c_uni2, 
				ref string p_ggalbtip_cod, 
				ref int? p_n_albaran, 
				ref string p_n_lin_alb, 
				ref string p_gacaja_cod, 
				DateTime? p_galotes_f_cad, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__SGA_LLENA_CAJA_DESDE_RECEPCION_VVVVNNVVVVVNNioVioNioVioVDoVoV v_sga_llena_caja_desde_recepcion;
				try {
					v_sga_llena_caja_desde_recepcion = Funcion.Crear<__SGA_LLENA_CAJA_DESDE_RECEPCION_VVVVNNVVVVVNNioVioNioVioVDoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_LLENA_CAJA_DESDE_RECEPCION", ex);
								}
								try {
				v_sga_llena_caja_desde_recepcion(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggpedtip_cod, 
					p_n_pedido, 
					p_n_lin_ped, 
					p_gvpalletip_cod, 
					p_gaart_cod, 
					p_lote, 
					p_gaalmnom_cod, 
					p_gaubic_cod, 
					p_c_uni1, 
					p_c_uni2, 
					ref p_ggalbtip_cod, 
					ref p_n_albaran, 
					ref p_n_lin_alb, 
					ref p_gacaja_cod, 
					p_galotes_f_cad, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
									throw new SpyroException(ex.Message, "RF_SGA_PKG.SGA_LLENA_CAJA_DESDE_RECEPCION", ex);
								}
							}
			
							/// <summary>
				/// Llama a SGA_LLENA_CAJA_DESDE_RECEPCION y eleva una excepción en caso de error. Utiliza la versión 
				/// sobrecargada (con el parámetro p_mensaje_error) para llamar a la versión original.
				/// </summary>
				public static void SGA_LLENA_CAJA_DESDE_RECEPCION(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[VARCHAR2(8)] string p_ggpedtip_cod, 
					[NUMBER] int? p_n_pedido, 
					[NUMBER] int? p_n_lin_ped, 
					[VARCHAR2(4)] string p_gvpalletip_cod, 
					[VARCHAR2(20)] string p_gaart_cod, 
					[VARCHAR2(20)] string p_lote, 
					[VARCHAR2(6)] string p_gaalmnom_cod, 
					[VARCHAR2(10)] string p_gaubic_cod, 
					[NUMBER(13, 4)] decimal? p_c_uni1, 
					[NUMBER(13, 4)] decimal? p_c_uni2, 
					[VARCHAR2(8)] ref string p_ggalbtip_cod, 
					[NUMBER] ref int? p_n_albaran, 
					[VARCHAR2(4)] ref string p_n_lin_alb, 
					[VARCHAR2(20)] ref string p_gacaja_cod, 
					[DATE] DateTime? p_galotes_f_cad, 
					[VARCHAR2] out string p_mensaje_info)
				{
											var v_copia_p_ggalbtip_cod = p_ggalbtip_cod;
				    						var v_copia_p_n_albaran = p_n_albaran;
				    						var v_copia_p_n_lin_alb = p_n_lin_alb;
				    						var v_copia_p_gacaja_cod = p_gacaja_cod;
				    
					SGA_LLENA_CAJA_DESDE_RECEPCION(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_tip_vc, 
						p_ggpedtip_cod, 
						p_n_pedido, 
						p_n_lin_ped, 
						p_gvpalletip_cod, 
						p_gaart_cod, 
						p_lote, 
						p_gaalmnom_cod, 
						p_gaubic_cod, 
						p_c_uni1, 
						p_c_uni2, 
						ref v_copia_p_ggalbtip_cod, 
						ref v_copia_p_n_albaran, 
						ref v_copia_p_n_lin_alb, 
						ref v_copia_p_gacaja_cod, 
						p_galotes_f_cad, 
						out var v_copia_p_mensaje_info,
						out var p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
											throw new SpyroException(p_mensaje_error, "RF_SGA_PKG.SGA_LLENA_CAJA_DESDE_RECEPCION");
					
											p_ggalbtip_cod = v_copia_p_ggalbtip_cod;
				    						p_n_albaran = v_copia_p_n_albaran;
				    						p_n_lin_alb = v_copia_p_n_lin_alb;
				    						p_gacaja_cod = v_copia_p_gacaja_cod;
				    						p_mensaje_info = v_copia_p_mensaje_info;
				    					
									}	
			
			#endregion

			}
}